#ifndef PX_GAMEINSTANCE_H
#define PX_GAMEINSTANCE_H
#include "PainterEngine_Startup.h"
#include "PX_Object_GameNote.h"
#include "PX_Object_ClickBar.h"
#include "PX_Object_ScorePanel.h"
#include "PX_Object_Initialize.h"
#include "PX_Object_GameTuner.h"
#define PX_GAMEINSTANCE_MAX_SUPPORT_TRACKS 16
#define PX_GAMEINSTANCE_ELAPSED_ATOM  5

typedef enum 
{
	PX_GAMEINSTANCE_STATE_CONFIG,
	PX_GAMEINSTANCE_STATE_LOADING,
	PX_GAMEINSTANCE_STATE_COUNTERDOWN,
	PX_GAMEINSTANCE_STATE_GAMEING,
}PX_GAMEINSTANCE_STATE;

typedef struct
{
	px_int elapsed_reserved;
	px_float z;
	px_float GameTrackElapsed[PX_GAMEINSTANCE_MAX_SUPPORT_TRACKS];
	px_bool eGameTrack[PX_GAMEINSTANCE_MAX_SUPPORT_TRACKS];

	PX_Object* piano_keyboard;
	PX_Object* clickbar;
	PX_Object* scorepanel;
	PX_Object* Loading;
	PX_Object* CounterDown;
	PX_Object* Config;
	px_int last_leftHandle;
	px_int last_rightHandle;

	PX_PianoModel pianoModel;
	PX_Midi Midi;
	PX_Sound sound;
	PX_World world;
	PX_Runtime* pruntime;
	PX_FontModule fm24, fm32, fm64;

	px_char name[128];

	PX_PianoKey_Parameters keyparam[88];
	PX_PianoSoundboard_Parameters soundboardparam;
	px_float volume;
	px_float speed;

	PX_GAMEINSTANCE_STATE state;

	px_dword elapsed;
}PX_GameInstance;


px_bool PX_GameInstanceInitialize(PX_Runtime* pruntime, PX_GameInstance* pGameInstance, const px_char name[], px_float speed, px_byte midi_data[], px_int midiSize);
px_void PX_GameInstanceUpdate(PX_GameInstance* pGameInstance, px_dword elapsed);
px_void PX_GameInstanceRender(px_surface *psurface,PX_GameInstance* pGameInstance, px_dword elapsed);
px_void PX_GameInstancePostEvent(PX_GameInstance* pGameInstance, PX_Object_Event e);
px_void PX_GameInstanceFree(PX_GameInstance* pGameInstance);
#endif