#include "PX_Object_ClickBar.h"

px_void PX_Object_ClickBarUpdate(PX_Object* pObject, px_dword elapsed)
{
	px_int i;
	PX_Object_ClickBar* pDesc = PX_ObjectGetDesc(PX_Object_ClickBar, pObject);
	pDesc->elapsed += elapsed;

	pObject->Height = 32;
	pObject->Width = pDesc->pWorld->surface_width *5/8.f;
	pObject->x = (pDesc->pWorld->surface_width - pObject->Width) / 2;
	pObject->y = 256;

	for (i = 0; i < PX_COUNTOF(pDesc->Note); i++)
	{
		if (pDesc->Note[i].delay)
		{
			px_float step = (pObject->Width - PX_OBJECT_CLICKBAR_CHECKX) / pDesc->Note[i].delay;
			px_float abs_x = pObject->x+ pObject->Width - step * pDesc->Note[i].elapsed;

			if (!pDesc->Note[i].bcheck&&pDesc->Note[i].elapsed> pDesc->Note[i].delay+180)
			{
				if (!pDesc->Note[i].missmark)
				{
					PX_Object* pMiss;
					pDesc->Note[i].missmark = PX_TRUE;
					PX_ObjectExecuteEvent(pObject, PX_OBJECT_BUILD_EVENT(PX_OBJECT_CLICKBAR_EVENT_MISS));
					pMiss = PX_Object_FloatTextCreate(pDesc->pruntime, pDesc->pWorld, abs_x, pObject->y + pObject->Height / 2, pDesc->fm, PX_OBJECT_FLOATTEXT_TYPE_MISS);
					PX_WorldAddObject(pDesc->pWorld, pMiss);
				}
			}

			if (pDesc->Note[i].bcheck)
			{

				pDesc->Note[i].delay = 0;
				pDesc->Note[i].elapsed = 0;
				PX_ObjectExecuteEvent(pObject, PX_OBJECT_BUILD_EVENT_INT(PX_OBJECT_CLICKBAR_EVENT_ADDSCORE, pDesc->Note[i].clickscore));
				PX_WorldAddObject(pDesc->pWorld, PX_Object_Explosion02Create(pDesc->pruntime, pDesc->pWorld, abs_x, pObject->y + pObject->Height / 2));

				if (pDesc->Note[i].clickscore==100)
				{
					PX_Object *pMiss = PX_Object_FloatTextCreate(pDesc->pruntime, pDesc->pWorld,\
						abs_x, pObject->y + pObject->Height / 2, pDesc->fm, PX_OBJECT_FLOATTEXT_TYPE_PREFECT);
					PX_WorldAddObject(pDesc->pWorld, pMiss);
				}
				else if (pDesc->Note[i].clickscore == 80)
				{
					PX_Object* pMiss = PX_Object_FloatTextCreate(pDesc->pruntime, pDesc->pWorld, \
						abs_x, pObject->y + pObject->Height / 2, pDesc->fm, PX_OBJECT_FLOATTEXT_TYPE_EXCELLENT);
					PX_WorldAddObject(pDesc->pWorld, pMiss);
				}
				else
				{
					PX_Object* pMiss = PX_Object_FloatTextCreate(pDesc->pruntime, pDesc->pWorld, \
						abs_x, pObject->y + pObject->Height / 2, pDesc->fm, PX_OBJECT_FLOATTEXT_TYPE_GOOD);
					PX_WorldAddObject(pDesc->pWorld, pMiss);
				}
			}
			else
			{
				pDesc->Note[i].elapsed += elapsed;
			}

			
			
		}
	}
}

px_void PX_Object_ClickBarRender(px_surface* psurface, PX_Object* pObject, px_dword elapsed)
{
	PX_Object_ClickBar* pDesc = PX_ObjectGetDesc(PX_Object_ClickBar, pObject);
	px_int i,x,y;

	
	pDesc->target_displaylen = 16;
	PX_GeoDrawSolidRoundRect(psurface, (px_int)pObject->x, (px_int)pObject->y, (px_int)(pObject->x + pObject->Width), (px_int)(pObject->y + pObject->Height), pObject->Height / 2, PX_COLOR(96, 255, 255, 255));
	PX_GeoDrawRoundRect(psurface, (px_int)pObject->x, (px_int)pObject->y, (px_int)(pObject->x + pObject->Width), (px_int)(pObject->y + pObject->Height), pObject->Height / 2,2, PX_COLOR(255, 255, 255, 255));

	for (i = 0; i < PX_COUNTOF(pDesc->Note); i++)
	{
		px_float relx,y, step;

		y =pObject->y+pObject->Height / 2;
		if (pDesc->Note[i].delay)
		{
			px_float a = 1;
			px_float schedule;
			step = (pObject->Width - PX_OBJECT_CLICKBAR_CHECKX) / pDesc->Note[i].delay;
			relx = pObject->Width - step * pDesc->Note[i].elapsed;
			if (relx <= 0)
			{
				pDesc->Note[i].delay = 0;
				pDesc->Note[i].elapsed = 0;
				continue;
			}
			if (relx < PX_OBJECT_CLICKBAR_CHECKX)
			{
				a = relx / PX_OBJECT_CLICKBAR_CHECKX;
			}
			if (relx > pObject->Width - PX_OBJECT_CLICKBAR_CHECKX)
			{
				a = (pObject->Width - relx) / PX_OBJECT_CLICKBAR_CHECKX;
			}
			schedule = (relx - PX_OBJECT_CLICKBAR_CHECKX) / (pObject->Width - PX_OBJECT_CLICKBAR_CHECKX);
			PX_GeoDrawSolidCircle(psurface, (px_int)(pObject->x + relx), (px_int)y,3, PX_COLOR((px_byte)(255*a), 255, 255, 255));
			if (schedule>0)
			{
				PX_GeoDrawCircle(psurface, (px_int)(pObject->x + relx), (px_int)y, (px_int)(3+schedule*64), (px_int)(1+schedule*2),\
					PX_COLOR((px_byte)(255 * (1-schedule)), 255, 255, 255));
			}

			if (PX_ABS(relx- PX_OBJECT_CLICKBAR_CHECKX)<= PX_OBJECT_CLICKBAR_SCANWIDTH)
			{
				pDesc->target_displaylen = 64;
			}
		}
	}


	do 
	{
		px_float dis = pDesc->target_displaylen - pDesc->current_displaylen;
		if (PX_ABS(dis)<2)
		{
			pDesc->current_displaylen= pDesc->target_displaylen;
		}
		else
		{
			if (PX_ABS(dis * elapsed) / 200.f<PX_ABS(dis))
			{
				pDesc->current_displaylen += dis  * elapsed / 200.f;
			}
			else
			{
				pDesc->current_displaylen = pDesc->target_displaylen;
			}
			
		}
	} while (0);

	for (x= (px_int)(PX_OBJECT_CLICKBAR_CHECKX-pDesc->current_displaylen/2);x< (px_int)(PX_OBJECT_CLICKBAR_CHECKX + pDesc->current_displaylen / 2);x++)
	{
		px_float a;
		px_byte ba;
		a = PX_ABS(x - PX_OBJECT_CLICKBAR_CHECKX) / pDesc->current_displaylen * 2;
		if (a > 1)a = 1;
		ba = (px_byte)((1 - a) * 255);
		for (y=(px_int)pObject->y;y<(px_int)pObject->y+pObject->Height;y++)
		{
			PX_SurfaceDrawPixel(psurface, (px_int)(x+pObject->x), y, PX_COLOR(ba, 255, 255, 255));
		}
	}

}

px_void PX_Object_ClickBarOnExecure(PX_Object* pObject, PX_Object_Event e, px_void* ptr)
{
	px_int i;
	px_int clickIndex = -1;
	px_dword Elapsed = 0;
	PX_Object_ClickBar* pDesc = PX_ObjectGetDesc(PX_Object_ClickBar, pObject);
	for (i = 0; i < PX_COUNTOF(pDesc->Note); i++)
	{
		if (pDesc->Note[i].delay)
		{
			px_int distanc = (px_int)(pDesc->Note[i].delay * 1.0f - pDesc->Note[i].elapsed);
			if (PX_ABS(distanc) < 180)
			{
				if (pDesc->Note[i].elapsed > Elapsed)
				{
					clickIndex = i;
					Elapsed = pDesc->Note[i].elapsed;
				}

			}
		}
	}

	if (clickIndex == -1)
	{
		PX_Object* pMiss;
		pMiss = PX_Object_FloatTextCreate(pDesc->pruntime, pDesc->pWorld, pObject->x + PX_OBJECT_CLICKBAR_CHECKX, pObject->y + pObject->Height / 2, pDesc->fm, PX_OBJECT_FLOATTEXT_TYPE_MISS);
		PX_WorldAddObject(pDesc->pWorld, pMiss);
		PX_ObjectExecuteEvent(pObject, PX_OBJECT_BUILD_EVENT(PX_OBJECT_CLICKBAR_EVENT_MISS));
	}
	else
	{
		px_int distanc = (px_int)(pDesc->Note[clickIndex].delay * 1.0f - pDesc->Note[clickIndex].elapsed);
		pDesc->Note[clickIndex].bcheck = PX_TRUE;
		if (PX_ABS(distanc) < 60)
		{
			pDesc->Note[clickIndex].clickscore = 100;
		}
		else if (PX_ABS(distanc) < 120)
		{
			pDesc->Note[clickIndex].clickscore = 80;
		}
		else
		{
			pDesc->Note[clickIndex].clickscore = 60;
		}
	}
}

PX_Object* PX_Object_ClickBarCreate(PX_Runtime* pruntime, PX_World* pWorld, PX_FontModule* fm)
{
	PX_Object_ClickBar ClickBar;
	PX_Object* pObject;
	PX_memset(&ClickBar, 0, sizeof(PX_Object_ClickBar));
	ClickBar.pruntime = pruntime;
	ClickBar.pWorld = pWorld;
	ClickBar.fm = fm;
	pObject= PX_ObjectCreateEx(&pruntime->mp_game, 0, 0, 0, 0, 0, 0, 0, 0, PX_Object_ClickBarUpdate, PX_Object_ClickBarRender, 0, &ClickBar, sizeof(ClickBar));
	PX_ObjectRegisterEvent(pObject, PX_OBJECT_EVENT_CURSORDOWN, PX_Object_ClickBarOnExecure, PX_NULL);
	PX_ObjectRegisterEvent(pObject, PX_OBJECT_EVENT_KEYDOWN, PX_Object_ClickBarOnExecure, PX_NULL);
	return pObject;
}

px_void PX_Object_ClickBarTrigger(PX_Object* pObject, px_dword delay)
{
	PX_Object_ClickBar* pDesc = PX_ObjectGetDesc(PX_Object_ClickBar, pObject);
	px_int i;
	if (pDesc->elapsed==pDesc->lastTriggerTime)
	{
		return;
	}
	for (i = 0; i < PX_COUNTOF(pDesc->Note); i++)
	{
		if (pDesc->Note[i].delay==0)
		{
			pDesc->Note[i].delay = delay;
			pDesc->Note[i].elapsed = 0;
			pDesc->Note[i].bcheck = 0;
			pDesc->Note[i].missmark = 0;
			pDesc->Note[i].clickscore = 0;
			pDesc->elapsed = pDesc->lastTriggerTime;
			return;
		}
	}
}

