#include "PX_Object_Explosion.h"
px_void PX_Object_Explosion01Render(px_surface* psurface, PX_Object *pObject, px_dword elapsed)
{
	PX_Object_Explosion01* pDesc = PX_ObjectGetDesc(PX_Object_Explosion01, pObject);
	PX_ParticalLauncherRender(psurface, &pDesc->launcher, elapsed);
}

px_void PX_Object_Explosion01Update(PX_Object* pObject, px_dword elapsed)
{
	PX_Object_Explosion01* pDesc = PX_ObjectGetDesc(PX_Object_Explosion01, pObject);
	pDesc->elapsed+=elapsed;
	if (pDesc->elapsed>2000)
	{
		PX_WorldRemoveObject(pDesc->pWorld, pObject);
	}
}


px_void PX_Object_Explosion01Free(PX_Object *pObject)
{
	PX_Object_Explosion01* pDesc = PX_ObjectGetDesc(PX_Object_Explosion01, pObject);
	PX_ParticalLauncherFree(&pDesc->launcher);
}

PX_Object* PX_Object_Explosion01Create(PX_Runtime* pruntime, PX_World* pWorld, px_float x, px_float y)
{
	PX_Object* pObject;
	PX_Object_Explosion01 desc;
	PX_ParticalLauncher_InitializeInfo info;
	PX_memset(&desc, 0, sizeof(desc));
	desc.pruntime = pruntime;
	desc.pWorld = pWorld;
	PX_ParticalLauncherInitializeDefaultInfo(&info);
	info.velocity = 150;
	info.deviation_velocity_max = 0;
	info.deviation_velocity_min = -100;
	info.direction = PX_POINT(0, -1, 0);
	info.ak = 0.65f;
	info.launchCount = 8;
	info.generateDuration = 0;
	info.maxCount = 8;
	info.alphaincrease = -1;
	info.alive = 2000;
	info.deviation_atomsize_max = 0;
	info.deviation_atomsize_min = -0.8f;
	info.deviation_rangAngle = 60;
	info.position = PX_POINT(x, y, 0);
	if(PX_rand()&1)
		info.tex = PX_ResourceLibraryGetTexture(&pruntime->ResourceLibrary, "partical01.traw");
	else
		info.tex = PX_ResourceLibraryGetTexture(&pruntime->ResourceLibrary, "partical02.traw");
	PX_ParticalLauncherInitialize(&desc.launcher, &pruntime->mp_game, info);
	pObject= PX_ObjectCreateEx(&pruntime->mp_game, PX_NULL, x, y, 0, 0, 0, 0, 0, PX_Object_Explosion01Update, PX_Object_Explosion01Render, PX_Object_Explosion01Free, &desc, sizeof(desc));
	return pObject;
}


px_void PX_Object_Explosion02Render(px_surface* psurface, PX_Object* pObject, px_dword elapsed)
{
	PX_Object_Explosion02* pDesc = PX_ObjectGetDesc(PX_Object_Explosion02, pObject);
	px_float a;
	px_float size;
	px_float angle;
	a = 1-pDesc->elapsed / 500.f;
	size = 100+pDesc->elapsed / 10.0f;
	angle = pDesc->elapsed / 500.f * 90.f;
	PX_GeoDrawBorder(psurface, (px_int)(pObject->x - size / 2), (px_int)(pObject->y - size / 2), \
		(px_int)(pObject->x + size / 2), (px_int)(pObject->y + size / 2),3, \
		PX_COLOR((px_byte)(a * 255), 255, 255, 255)\
	);
	PX_GeoDrawRing(psurface, (px_int)pObject->x, (px_int)pObject->y, 35, 3, PX_COLOR((px_byte)(a * 255), 255, 255, 255), -90 + (px_int)angle, (px_int)angle);
	PX_GeoDrawRing(psurface, (px_int)pObject->x, (px_int)pObject->y, 35, 3, PX_COLOR((px_byte)(a * 255), 255, 255, 255),  90+ (px_int)angle, (px_int)angle+180);
	PX_GeoDrawSolidCircle(psurface, (px_int)pObject->x, (px_int)pObject->y, 5, PX_COLOR((px_byte)(a * 255), 255, 255, 255));
	PX_ParticalLauncherRender(psurface, &pDesc->launcher, elapsed);
}

px_void PX_Object_Explosion02Update(PX_Object* pObject, px_dword elapsed)
{
	PX_Object_Explosion02* pDesc = PX_ObjectGetDesc(PX_Object_Explosion02, pObject);
	pDesc->elapsed += elapsed;
	if (pDesc->elapsed > 500.f)
	{
		PX_WorldRemoveObject(pDesc->pWorld, pObject);
	}
}
px_void PX_Object_Explosion02Free(PX_Object* pObject)
{
	PX_Object_Explosion02* pDesc = PX_ObjectGetDesc(PX_Object_Explosion02, pObject);
	PX_ParticalLauncherFree(&pDesc->launcher);
}

PX_Object* PX_Object_Explosion02Create(PX_Runtime* pruntime, PX_World* pWorld, px_float x, px_float y)
{
	PX_Object_Explosion02 Desc;
	PX_Object* pObject;
	PX_ParticalLauncher_InitializeInfo info;
	PX_memset(&Desc, 0, sizeof(Desc));
	Desc.elapsed = 0;
	Desc.pruntime = pruntime;
	Desc.pWorld = pWorld;

	PX_ParticalLauncherInitializeDefaultInfo(&info);
	info.velocity = 600;
	info.deviation_velocity_max = 0;
	info.deviation_velocity_min = -580;
	info.direction = PX_POINT(0, -1, 0);
	info.ak = 3;
	info.launchCount = 8;
	info.generateDuration = 0;
	info.maxCount = 8;
	info.alphaincrease = -2;
	info.alive = 500;
	info.deviation_atomsize_max = 0;
	info.deviation_atomsize_min = -0.8f;
	info.deviation_rangAngle = 180;
	info.position = PX_POINT(x, y, 0);
	info.tex = PX_ResourceLibraryGetTexture(&pruntime->ResourceLibrary, "rect");
	PX_ParticalLauncherInitialize(&Desc.launcher, &pruntime->mp_game, info);
	pObject = PX_ObjectCreateEx(&pruntime->mp_game, PX_NULL, x, y, 0, 0, 0, 0, 0, PX_Object_Explosion02Update, PX_Object_Explosion02Render, PX_Object_Explosion02Free, &Desc, sizeof(Desc));
	return pObject;
}

