#include "PX_Object_FloatText.h"

px_void PX_Object_FloatTextRender(px_surface* psurface, PX_Object* pObject, px_dword elapsed)
{
	PX_Object_FloatText* pdesc = PX_ObjectGetDesc(PX_Object_FloatText, pObject);
	pdesc->elapsed += elapsed;
	if (pdesc->elapsed>1600)
	{
		PX_WorldRemoveObject(pdesc->pWorld, pObject);
	}
	else
	{
		px_float a = 1-pdesc->elapsed / 1600.f;
		switch (pdesc->type)
		{
		case PX_OBJECT_FLOATTEXT_TYPE_GOOD:
		{
			PX_FontModuleDrawText(psurface, pdesc->fm, (px_int)pObject->x, (px_int)(pObject->y - pdesc->elapsed / 10.f), PX_ALIGN_MIDBOTTOM, "Good", PX_COLOR((px_byte)(a * 255), 255, 255, 255));
		}
		break;
		case PX_OBJECT_FLOATTEXT_TYPE_EXCELLENT:
		{
			PX_FontModuleDrawText(psurface, pdesc->fm, (px_int)pObject->x, (px_int)(pObject->y - pdesc->elapsed / 10.f), PX_ALIGN_MIDBOTTOM, "Excellent", PX_COLOR((px_byte)(a * 255), 255, 160, 233));
		}
		break;
		case PX_OBJECT_FLOATTEXT_TYPE_PREFECT:
		{
			PX_FontModuleDrawText(psurface, pdesc->fm, (px_int)pObject->x, (px_int)(pObject->y - pdesc->elapsed / 10.f), PX_ALIGN_MIDBOTTOM, "Prefect", PX_COLOR((px_byte)(a * 255), 255, 174, 26));
		}
		break;
		default:
		case PX_OBJECT_FLOATTEXT_TYPE_MISS:
		{
			PX_FontModuleDrawText(psurface, pdesc->fm, (px_int)pObject->x, (px_int)(pObject->y - pdesc->elapsed / 10.f), PX_ALIGN_MIDBOTTOM, "Miss", PX_COLOR((px_byte)(a * 255), 255, 0, 0));
		}
		break;
		}
	}
}


PX_Object* PX_Object_FloatTextCreate(PX_Runtime* pruntime, PX_World* pWorld, px_float x, px_float y, PX_FontModule* fm, PX_OBJECT_FLOATTEXT_TYPE type)
{
	PX_Object_FloatText Desc;
	PX_memset(&Desc, 0, sizeof(Desc));
	Desc.pWorld = pWorld;
	Desc.pruntime = pruntime;
	Desc.type = type;
	Desc.fm = fm;
	return PX_ObjectCreateEx(&pruntime->mp_game, 0, x, y, -1, 0, 0, 0, 0, 0, PX_Object_FloatTextRender, 0, &Desc, sizeof (Desc));
}

