#include "PX_Object_GameNote.h"

px_void PX_Object_GameNote0Update(PX_Object* pObject, px_dword elapsed)
{
	PX_Object_GameNote0* pNode = PX_ObjectGetDesc(PX_Object_GameNote0,pObject);
	pObject->y += pNode->base.speed * elapsed / 1000;

	if (pObject->y>=pNode->pPiano->y)
	{
		if (pNode->base.note.opcode==PX_MIDI_OPCODE_KEYDOWN)
		{
			PX_PianoModelTrigger(pNode->ppianoModel, PX_MidiNoteToPianoKey(pNode->base.note.note));
			PX_Object_PianoSetKeyDown(pNode->pPiano, PX_MidiNoteToPianoKey(pNode->base.note.note), PX_TRUE);
			PX_WorldAddObject(pNode->pWorld, PX_Object_Explosion01Create(pNode->pruntime, pNode->pWorld, pObject->x, pObject->y));
		}
		else if (pNode->base.note.opcode == PX_MIDI_OPCODE_KEYUP)
		{
			PX_Object_PianoSetKeyDown(pNode->pPiano, PX_MidiNoteToPianoKey(pNode->base.note.note), PX_FALSE);
		}
		
		PX_WorldRemoveObject(pNode->pWorld, pObject);
	}
}

px_void PX_Object_GameNote0Render(px_surface *psurface,PX_Object* pObject, px_dword elapsed)
{
	PX_Object_GameNote0* pNode = PX_ObjectGetDesc(PX_Object_GameNote0, pObject);
	PX_TEXTURERENDER_BLEND blend;
	if (pNode->base.note.opcode==PX_MIDI_OPCODE_KEYDOWN)
	{
		blend.alpha = pNode->base.color._argb.a / 255.0f;
		blend.hdr_R = pNode->base.color._argb.r / 255.0f;
		blend.hdr_G = pNode->base.color._argb.g / 255.0f;
		blend.hdr_B = pNode->base.color._argb.b / 255.0f;
		PX_AnimationUpdate(&pNode->animation, elapsed);
		PX_AnimationRender_scale(psurface, &pNode->animation, (px_int)pObject->x, (px_int)pObject->y, pNode->scale, PX_ALIGN_CENTER, &blend);
	}
	
}



PX_Object* PX_Object_GameNote0Create(PX_Runtime* pruntime, PX_World* pWorld, PX_PianoModel* ppianoModel, PX_Object* ppiano,\
	px_float x, px_float y, px_float z, px_float speed, PX_Midi_Note note, px_color color)
{
	PX_Object* pObject;
	PX_Object_GameNote0 note0;
	PX_memset(&note0, 0, sizeof(note0));
	note0.base.color = color;
	note0.base.speed = speed;
	note0.base.note = note;
	note0.pWorld = pWorld;
	note0.pPiano = ppiano;
	note0.ppianoModel = ppianoModel;
	note0.pruntime = pruntime;
	note0.scale = (px_float)PX_randRange(0.35, 1);
	PX_AnimationCreate(&note0.animation, PX_ResourceLibraryGetAnimationLibrary(&pruntime->ResourceLibrary, "star.2dx"));
	pObject = PX_ObjectCreateEx(&pruntime->mp_game, PX_NULL, x, y, z, 1, 1, 0, 0x1201, PX_Object_GameNote0Update, PX_Object_GameNote0Render, PX_NULL, &note0, sizeof(note0));
	return pObject;
}

