#include "PX_Object_Initialize.h"

px_void PX_Object_InitializeUpdate(PX_Object* pObject, px_dword elapsed)
{
	PX_Object_Initialize* pDesc = PX_ObjectGetDesc(PX_Object_Initialize, pObject);
	if (pDesc->initKey<88)
	{
		PX_PianoModelInitializeNote(pDesc->pPianoModel, pDesc->initKey, pDesc->keyparam, pDesc->soundboardparam);
		pDesc->initKey++;
	}
	else
	{
		PX_ObjectExecuteEvent(pObject, PX_OBJECT_BUILD_EVENT(PX_OBJECT_INITIALIZE_EVENT_DONE));
		PX_WorldRemoveObject(pDesc->pWorld, pObject);

	}

}

px_void PX_Object_InitializeRender(px_surface *prendersurface,PX_Object* pObject, px_dword elapsed)
{
	PX_Object_Initialize* pDesc = PX_ObjectGetDesc(PX_Object_Initialize, pObject);
	px_char content[64];
	PX_sprintf1(content, sizeof(content), "Physics-Based Piano Sound Model Building:%1.2%", PX_STRINGFORMAT_FLOAT(pDesc->initKey *100.f/ 88.f));
	PX_Object_MessageBoxAlert(pDesc->msgbox, content);
	PX_ObjectRender(prendersurface, pDesc->msgbox,elapsed);
	
}

px_void PX_Object_InitializeFree(PX_Object* pObject)
{
	PX_Object_Initialize* pDesc = PX_ObjectGetDesc(PX_Object_Initialize, pObject);
	PX_ObjectDelete(pDesc->msgbox);
}

PX_Object* PX_Object_InitializeCreate(PX_Runtime* pruntime, PX_World* pWorld, PX_FontModule* fm, PX_PianoModel* pPianoModel, PX_PianoKey_Parameters* keyparam, PX_PianoSoundboard_Parameters* soundboardparam)
{
	PX_Object_Initialize desc;
	desc.fm = fm;
	desc.pPianoModel = pPianoModel;
	desc.pruntime = pruntime;
	desc.pWorld = pWorld;
	desc.initKey = 0;
	desc.soundboardparam = soundboardparam;
	desc.keyparam = keyparam;
	desc.msgbox = PX_Object_MessageBoxCreate(&pruntime->mp_game, 0, fm);
	PX_PianoModelInitializeData(pPianoModel);
	return PX_ObjectCreateEx(&pruntime->mp_game, 0, 0, 0, 0, 0, 0, 0, 0, PX_Object_InitializeUpdate, PX_Object_InitializeRender, PX_Object_InitializeFree, &desc, sizeof(desc));
}

