#include "PX_Object_ScorePanel.h"

px_void PX_Object_ScorePanelRender(px_surface* psurface, PX_Object* pObject, px_dword elapsed)
{
	px_char content[64];
	px_float dis;
	PX_Object_ScorePanel* pDesc = PX_ObjectGetDesc(PX_Object_ScorePanel, pObject);
	pObject->x = pDesc->pruntime->surface_width / 2.f;
	pObject->y = 96;
	pDesc->lastupdateelapsed += elapsed;
	dis = pDesc->score- pDesc->current_displayscore;
	if (dis>600)
	{
		pDesc->current_displayscore = pDesc->score - 600;
	}
	else if (dis>elapsed/5)
	{
		pDesc->current_displayscore += elapsed / 2.f;
	}
	else
	{
		pDesc->current_displayscore = pDesc->score;
	}

	PX_sprintf2(content, sizeof(content), "%1(speed:%2)", PX_STRINGFORMAT_STRING(pDesc->Name), PX_STRINGFORMAT_INT(pDesc->speed));
	PX_FontModuleDrawText(psurface, pDesc->fm32, 5, 32, PX_ALIGN_LEFTTOP, content, PX_COLOR_WHITE);

	PX_itoa((px_int)pDesc->current_displayscore, content, sizeof(content), 10);
	PX_SurfaceClear(&pDesc->scaleTexture, 0, 0, pDesc->scaleTexture.width, pDesc->scaleTexture.height, PX_COLOR(0, 0, 0, 0));
	PX_FontModuleDrawText(&pDesc->scaleTexture, pDesc->fm64, pDesc->scaleTexture.width / 2, pDesc->scaleTexture.height / 2, PX_ALIGN_CENTER, content, PX_COLOR_WHITE);
	if (pDesc->lastupdateelapsed>300)
	{
		PX_TextureRender(psurface, &pDesc->scaleTexture, (px_int)pObject->x, (px_int)pObject->y, PX_ALIGN_CENTER, PX_NULL);
	}
	else
	{
		PX_TEXTURERENDER_BLEND blend;
		blend.alpha = pDesc->lastupdateelapsed / 300.f;
		blend.hdr_R = 1;
		blend.hdr_G = 1;
		blend.hdr_B = 1;
		PX_TextureRenderEx(psurface, &pDesc->scaleTexture, (px_int)pObject->x, (px_int)pObject->y, PX_ALIGN_CENTER, &blend, 2 - blend.alpha, 0);
	}
	PX_sprintf2(content, sizeof(content), "combo:%1|Max:%2", PX_STRINGFORMAT_INT(pDesc->combo), PX_STRINGFORMAT_INT(pDesc->max_combo));
	PX_FontModuleDrawText(psurface, pDesc->fm32, (px_int)pObject->x, (px_int)pObject->y+64, PX_ALIGN_CENTER, content, PX_COLOR_WHITE);

}

px_void PX_Object_ScorePanelFree(PX_Object* pObject)
{
	PX_Object_ScorePanel* pDesc = PX_ObjectGetDesc(PX_Object_ScorePanel, pObject);
	PX_TextureFree(&pDesc->scaleTexture);
}
PX_Object* PX_Object_ScorePanelCreate(PX_Runtime* pruntime, PX_World* pWorld, PX_FontModule* fm64, PX_FontModule* fm32, const px_char name[], px_int speed)
{
	PX_Object* pObject;
	PX_Object_ScorePanel desc;
	PX_memset(&desc, 0, sizeof(desc));
	desc.pruntime = pruntime;
	desc.pWorld = pWorld;
	desc.fm32 = fm32;
	desc.fm64 = fm64;
	desc.score = 0;
	desc.current_displayscore = 0;
	desc.Name = name;
	desc.speed = speed;
	PX_TextureCreate(&pruntime->mp_game, &desc.scaleTexture, 182, 52);
	pObject = PX_ObjectCreateEx(&pruntime->mp_game, 0, 0, 0, 0, 0, 0, 0, 0, 0, PX_Object_ScorePanelRender, PX_Object_ScorePanelFree, &desc, sizeof(desc));
	return pObject;
}

px_void PX_Object_ScorePanelAddScore(PX_Object* pObject,px_int score)
{
	PX_Object_ScorePanel* pDesc = PX_ObjectGetDesc(PX_Object_ScorePanel, pObject);
	pDesc->score += (px_float)(score +pDesc->combo);
	pDesc->lastupdateelapsed = 0;
	pDesc->combo++;
	if (pDesc->combo>pDesc->max_combo)
	{
		pDesc->max_combo = pDesc->combo;
	}
}

px_void PX_Object_ScorePanelDisableCombo(PX_Object* pObject)
{
	PX_Object_ScorePanel* pDesc = PX_ObjectGetDesc(PX_Object_ScorePanel, pObject);
	pDesc->combo = 0;
}

