#include "PainterEngine_Application.h"
PX_Application App;

#include "PX_Resource_partical01.h"
#include "PX_Resource_partical02.h"
#include "PX_Resource_star.h"
px_bool PX_ApplicationInitialize(PX_Application *pApp,px_int screen_width,px_int screen_height)
{
	PX_Json json;
	px_char name[128] = {0};
	px_float speed=0;
	PX_IO_Data io;
	
	PX_ApplicationInitializeDefault(&pApp->runtime, screen_width, screen_height);

	PX_JsonInitialize(&pApp->runtime.mp, &json);
	if (PX_LoadJsonFromFile(&json, "assets/info.txt"))
	{
		PX_strcpy(name, PX_JsonGetString(&json, "name"), sizeof(name));
		speed = (px_float)PX_JsonGetNumber(&json, "speed");
	}
	PX_JsonFree(&json);

	if (!PX_SoundPlayInitialize(&pApp->runtime.mp, &pApp->runtime.soundplay))return PX_FALSE;
	if(!PX_AudioInitialize(&pApp->runtime.soundplay))return PX_FALSE;

	if (!PX_ResourceLibraryLoad(&pApp->runtime.ResourceLibrary, PX_RESOURCE_TYPE_TEXTURE, partical01, sizeof(partical01), "partical01.traw")) 
		return PX_FALSE;

	if (!PX_ResourceLibraryLoad(&pApp->runtime.ResourceLibrary, PX_RESOURCE_TYPE_TEXTURE, partical02, sizeof(partical02), "partical02.traw"))
		return PX_FALSE;

	if (!PX_ResourceLibraryLoad(&pApp->runtime.ResourceLibrary, PX_RESOURCE_TYPE_ANIMATIONLIBRARY, star, sizeof(star), "star.2dx"))
		return PX_FALSE;

	
	do 
	{
		px_texture recttex;
		PX_TextureCreate(&pApp->runtime.mp_resources, &recttex, 16, 16);
		PX_SurfaceClear(&recttex, 0, 0, 47, 47, PX_COLOR_WHITE);
		PX_ResourceLibraryAddTexture(&pApp->runtime.ResourceLibrary, "rect", &recttex);
		PX_TextureFree(&recttex);
	} while (0);
	
	
	io = PX_LoadFileToIOData("assets/play.mid");
	if (!io.size)
	{
		return PX_FALSE;
	}
	PX_GameInstanceInitialize(&pApp->runtime, &pApp->GameInstance, name, speed,io.buffer, io.size);
	PX_FreeIOData(&io);
	return PX_TRUE;
}

px_void PX_ApplicationUpdate(PX_Application *pApp,px_dword elapsed)
{
	PX_GameInstanceUpdate(&pApp->GameInstance, elapsed);
}

px_void PX_ApplicationRender(PX_Application *pApp,px_dword elapsed)
{
	px_surface *pRenderSurface=&pApp->runtime.RenderSurface;
	PX_RuntimeRenderClear(&pApp->runtime,PX_OBJECT_UI_DEFAULT_BACKGROUNDCOLOR);
	PX_GameInstanceRender(pRenderSurface ,&pApp->GameInstance, elapsed);
}

px_void PX_ApplicationPostEvent(PX_Application *pApp,PX_Object_Event e)
{
	PX_ApplicationEventDefault(&pApp->runtime, e);
	PX_GameInstancePostEvent(&pApp->GameInstance, e);

}

